"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startDevServer = startDevServer;

var _config = require("../../config");

var _static = require("../static");

var _httpServer = require("./httpServer");

var _app = require("./app");

var _messageHandler = require("./messageHandler");

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function startDevServer(_x) {
  return _startDevServer.apply(this, arguments);
}

function _startDevServer() {
  _startDevServer = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(platformType) {
    var plugins,
        cosmosConfig,
        app,
        pluginCleanupCallbacks,
        httpServer,
        msgHandler,
        cleanUp,
        _cleanUp,
        _iterator,
        _step,
        plugin,
        pluginReturn,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _cleanUp = function _cleanUp3() {
              _cleanUp = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return pluginCleanupCallbacks.map(function (cleanup) {
                          return cleanup();
                        });

                      case 2:
                        _context.next = 4;
                        return httpServer.stop();

                      case 4:
                        msgHandler.cleanUp();

                      case 5:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return _cleanUp.apply(this, arguments);
            };

            cleanUp = function _cleanUp2() {
              return _cleanUp.apply(this, arguments);
            };

            plugins = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : [];
            cosmosConfig = (0, _config.detectCosmosConfig)();
            app = (0, _app.createApp)(platformType, cosmosConfig);

            if (cosmosConfig.staticPath) {
              (0, _static.serveStaticDir)(app, cosmosConfig.staticPath, cosmosConfig.publicUrl);
            }

            pluginCleanupCallbacks = [];
            httpServer = (0, _httpServer.createHttpServer)(cosmosConfig, app);
            _context2.next = 10;
            return httpServer.start();

          case 10:
            msgHandler = (0, _messageHandler.createMessageHandler)(httpServer.server);
            _context2.prev = 11;
            _iterator = _createForOfIteratorHelper(plugins);
            _context2.prev = 13;

            _iterator.s();

          case 15:
            if ((_step = _iterator.n()).done) {
              _context2.next = 23;
              break;
            }

            plugin = _step.value;
            _context2.next = 19;
            return plugin({
              cosmosConfig: cosmosConfig,
              httpServer: httpServer.server,
              expressApp: app,
              sendMessage: msgHandler.sendMessage
            });

          case 19:
            pluginReturn = _context2.sent;

            if (typeof pluginReturn === 'function') {
              pluginCleanupCallbacks.push(pluginReturn);
            }

          case 21:
            _context2.next = 15;
            break;

          case 23:
            _context2.next = 28;
            break;

          case 25:
            _context2.prev = 25;
            _context2.t0 = _context2["catch"](13);

            _iterator.e(_context2.t0);

          case 28:
            _context2.prev = 28;

            _iterator.f();

            return _context2.finish(28);

          case 31:
            _context2.next = 37;
            break;

          case 33:
            _context2.prev = 33;
            _context2.t1 = _context2["catch"](11);
            cleanUp();
            throw _context2.t1;

          case 37:
            return _context2.abrupt("return", cleanUp);

          case 38:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[11, 33], [13, 25, 28, 31]]);
  }));
  return _startDevServer.apply(this, arguments);
}