"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startWebServer = startWebServer;

var _httpProxy = require("./plugins/httpProxy");

var _openFile = require("./plugins/openFile");

var _userDepsFile = require("./plugins/userDepsFile");

var _webpack = require("./plugins/webpack");

var _cli = require("./shared/cli");

var _devServer = require("./shared/devServer");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function startWebServer() {
  return _startWebServer.apply(this, arguments);
}

function _startWebServer() {
  _startWebServer = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var plugins;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            plugins = [_openFile.openFile, _webpack.webpackDevServer, _httpProxy.httpProxy];

            if (shouldGenerateUserDepsFile()) {
              plugins.push(_userDepsFile.userDepsFile);
            }

            _context.next = 4;
            return (0, _devServer.startDevServer)('web', plugins);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _startWebServer.apply(this, arguments);
}

function shouldGenerateUserDepsFile() {
  // CLI support for --external-userdeps flag
  return Boolean((0, _cli.getCliArgs)().externalUserdeps);
}